# -------------------------------------
# [EZ-NET] ConfigReader
# Configuration file reader for CGI
#
# Date: 2004/04/11
# Version: 1.0.0
# Type: Class
#
# Copyright: (c) Easy Network
# Written by: Yuu Mitani
# Reference: http://www.ez-net.ne.jp/
# -------------------------------------

package ConfigReader;
use CEzObject;

@ISA = ('CEzObject');


# CONSTANTS
%SYS_INFO =
(
	'VersionInfo' => '1.0.0',
	'ClassInfo' => 'Easy Network ConfigReader Object'
);


# CONSTRUCTOR / DESTRUCTOR
# $[-]: Owner Object
# $[1]: Configuration file

sub new($)
{
	my $that = shift;
	my $this = new CEzObject();

	my $file = shift;

	$this->SetObjectInformation($SYS_INFO{'VersionInfo'}, $SYS_INFO{'ClassInfo'});

	$this->AddAttribute('filename', $file);

	$this->AddAttribute('ready', 0);
	$this->AddAttribute('data');

	return bless $this, $that;
}

sub DESTROY()
{
	my $this = shift;
	$this->CEzObject::DESTROY();
}

# METHOD

# --- Read Configuration Data
# $[r] ǂݍ߂ꍇ 1AłȂ 0B
# $[-] Owner Object
# $[1] filename = '' ȗ filename Kp܂
sub DataRead($)
{
	my $this = shift;
	my $filename = shift;
	
	# ȗ͑̒l擾
	$filename = $this->GetAttribute('filename') if (! $filename);

	if (open H_CONFIG, $filename)
	{
		# %conf ϐ config.txt l擾
		# ł data ɕێĂĂAɒǋL܂B
		my %conf = %{$this->GetAttribute('data')};

		# config t@C̑SeƍāA
		# Kvɉ %config ϐ֒lĂ܂B

		while (<H_CONFIG>)
		{
			# ܂ +( ) ɊY邩𒲂ׂ܂B
			if (/^\s*\+\(([^\s]*)\)\s*$/)
			{
				my $key = $1;
				my $value;
				
				# "+()"  "+)" ܂ł̒l擾܂B
				while (<H_CONFIG>)
				{
					# "+)" sI܂B
					last if ($_ =~ /^\s*\+\)\s*$/);

					# Ps擾Ċ̒lɒǉ܂B
					$value .= $_;
				}
				
				# HASH ɕۑ܂B $1 (HASH Key) ɒl擾łȂꍇ͖܂B
				$conf{$key} = $value if ($key);
			}
			# + n܂郉C𒲂ׁAϐɒl܂B
			elsif (/^\s*\+([^\s]*)\s+(.*)$/)
			{
				#  $1 (HASH Key) ɒl擾łȂꍇ͖܂B
				if ($1)
				{
					$conf{$1} = $2;
					$conf{$1} =~ s/\s*$//;
				}
			}
		}
		
		close H_CONFIG;
		
		# ǂݏI data ɐݒ肵āAԂXV܂B
		$this->SetAttribute('data', {%conf});
		$this->SetAttribute('ready', 1);
	}
	else
	{
		$this->Clear();
		$this->SetAttribute('ready', 0);
	}

	# Ԃ߂lƂ܂B
	return $this->GetAttribute('ready');
}

# --- 𒲂ׂ܂B
# $[r] 1: ready, 0: not ready
sub IsReady($)
{
	my $this = shift;
	return $this->GetAttribute('ready');
}

# --- Clear Data

sub Clear($)
{
	my $this = shift;

	$this->SetAttribute('data', undef);
	$this->SetAttribute('ready', 0);
}

# --- Get Keys
# @[r]: $data ĂL[̈ꗗ
# $[-]: Owner Object

sub GetKeys($)
{
	my $this = shift;
	
	return keys %{$this->GetAttribute('data')};
}

# --- GetValue
# $[r]: w肳ꂽL[̎l
# $[-]: Owner Object
# $[1]: L[

sub GetValue($$)
{
	my $this = shift;
	my $key = shift;
	
	my %data = %{$this->GetAttribute('data')};
	return $data{$key};
}

1;
