#!/usr/bin/perl

# -------------------------------
# 2004/04/11
# copyright(c) Easy Network
#
$IDENTIFIER	= 'EZ-NET Mail Form 1.0.1';
$URL		= 'http://program.station.ez-net.jp/';
$URL_LONG	= "${URL}products/cgi/MailForm/";
# -------------------------------

require '3rd/jcode.pl-2.13';

use lib 'modules';

use ConfigReader;
use ParamAnalyzer;
use CEzTime;


# [쐬ƂɎgsłB
$MAIL_NEWLINE = "\n";

# wb_[ƂďލڂƂ̃wb_łB
%MAIL_HEADERS =
(
	'mail_from'	=> 'From',
	'mail_to'	=> 'To',
	'subject'	=> 'Subject'
);

# Config ̍ځB
# IMPORTANTS ͕K{ځBOPTIONS ͔CӁB
# _FIXED ̂ق́AtB[hɓ₪Ă Config ̓eD悵܂B
# _OVERRIDE ̂ق́AtB[hɓ₪ꍇ Config ̓e㏑܂B
# _APPEND ̂ق́AtB[hɂ₪ꍇ Config ̓eɒǉ܂B
@IMPORTANTS_FIXED = ('sendmail', 'mail_to', 'enable_override', 'ok_result', 'ok_note', 'ng_result', 'ng_note', 'required_result', 'required_note');
@IMPORTANTS_APPEND = ('required');
@IMPORTANTS = (@IMPORTANTS_FIXED, @IMPORTANTS_APPEND);

@OPTIONS_FIXED = ('mail_header', 'mail_footer');
@OPTIONS_OVERRIDE = ('config_override', 'config_override_path');
@OPTIONS = (@OPTIONS_FIXED, @OPTIONS_OVERRIDE, @OPTIONS_APPEND);

@CONFIG_FIXED = (@IMPORTANTS_FIXED, @OPTIONS_FIXED);
@CONFIG_OVERRIDE = (@OPTIONS_OVERRIDE);
@CONFIG_APPEND = (@IMPORTANTS_APPEND);

# [{Ɋ܂߂ȂځB
@EXCLUDE_SYSTEM = ('__system_date__', '__system_version__', '__system_site__', '__system_url__');
@EXCLUDE = (@EXCLUDE_SYSTEM, @IMPORTANTS, @OPTIONS, (keys %MAIL_HEADERS), 'result_template', 'result_template_code', 'send_back_copy', 'name_from');

sub main()
{
	my $conf = new ConfigReader('config.txt');
	
	if ($conf->DataRead())
	{
		my %params;
		
		# --- D揇ʂlāA̎擾s܂BG[bZ[W͊֐B
		%params = &GetParams($conf);

		if (%params)
		{
			# --- G[bZ[W̐ݒ́Ae֐ōs܂B
			&Send(%params) if (&CheckParams(%params));
		}
	}
	else
	{
		&Error('cannot initialize myself.', undef);
	}
	
	undef $conf;
}

# LlɕK{̍ڂݒ肳Ă邩𒲂ׂ܂B
# G[bZ[W̏o͓͂ōs܂B
# $[r] 1  / 0 s
# %[1] Ll
sub CheckParams(%)
{
	my $result = 1;
	my %params = @_;
	
	# K{ڂ +required Őݒ肳Ă鍀ڂ̈ꗗ쐬܂B
	my @checklist = (@IMPORTANTS);
	push @checklist, split(",", $params{'required'});
	
	# ꗗɂāAlݒ肳ĂȂ̂ȂT܂B
	foreach (@checklist)
	{
		if (! $params{$_})
		{
			$result = &ErrorConfig($_, %params);
			last;
		}
	}
	
	return $result;
}

# Config t@C̓eƃtH[tB[hAŏIIȗLl肵܂B
# %[r] LȒl / s undef
# $[1] ConfigReader IuWFNgi{ݒǂݍݍς݁j
sub GetParams(%)
{
	my $conf = shift;
	my %result;
	
	my $params = new ParamAnalyzer();
	
	my %conf_fixed;
	my %conf_override;
	my $conf_append;
	
	my $file_override;
	
	# tH[tB[h擾܂B
	$params->Analyze();

	# Config ̃I[o[Chw肳Ă΁Aǂݍރt@C肵܂B
	if ($conf->GetValue('enable_override') eq 'yes')
	{
		$file_override = $params->GetValueScalar('config_override');
	}
	
	# ǂݍރt@C擾łĂΓǂݍ݂܂B
	if ($file_override)
	{
		# LȒl "." pXƂĐݒ肵܂B
		my $path = $conf->GetValue('config_override_path') || '.';
		
		# s "/" łꍇ͎菜܂B
		$path =~ s/\/$//;

		$conf->DataRead("$path/$file_override") || &Error("Cannot override: cannot access: $path/$file_override", %result);
	}
	
	# ConfigReader ̏Ă悤ȂΎ擾s܂B
	if ($conf->IsReady())
	{
		my %temp;
		
		# %result ɗDx̒Ⴂ conf t@C̐ݒRs[܂B
		%result = %{$conf->GetAttribute('data')};

		# %conf_* ֗D捀ڂm
		map($conf_fixed{$_} = $result{$_}, @CONFIG_FIXED);
		map($conf_override{$_} = $result{$_}, @CONFIG_OVERRIDE);
		map($conf_append{$_} = $result{$_}, @CONFIG_APPEND);

		# tH[tB[h̒l %result ̒l㏑܂B
		foreach (keys %{$params->GetAttribute('params')})
		{
			$result{$_} = join(',', $params->GetValueArray($_));
		}
		
		# %result  %conf ɊmۂD捀ڂ߂܂B
		map($result{$_} = $conf_fixed{$_}, @CONFIG_FIXED);
		
		foreach (@IMPORTANTS_APPEND)
		{
			# tH[tB[hɒlꍇ "," YāAConfig ̓eǋL܂B
			$result{$_} .= "," if ($result{$_});
			$result{$_} .= $conf_append{$_};
		}
	}
	else
	{
		# G[̏ꍇ undef Ԃ܂B
		undef %result;
	}

	undef $params;
	
	return %result;
}

# [̑Ms܂B
# G[bZ[W̏o͓͂ōs܂B
# %[0] 
sub Send(%)
{
	local @mail_data;
	local @x_header;
	
	local %data = @_;

	my $mail_header;
	my $mail_footer;
	my $send_address;
	
	# f[^Xg쐬܂B
	map($effective_data_list{$_} = '', keys %data);
	
	# ŗLwb_ǉ܂B
	my $datetime = new CEzTime();

	$data{'X-Mailer'} = $IDENTIFIER;
	$data{'X-Mailer-URL'} = $URL;

	# VXetB[ho^܂B
	$data{'__system_version__'} = $IDENTIFIER;
	$data{'__system_site__'} = $URL;
	$data{'__system_url__'} = $URL_LONG;
	$data{'__system_date__'} = $datetime->MakeDatetimeString();

	undef $datetime;
	
	# Ő󔒕菜܂B
	map($data{$_} =~ s/^\s+//, keys %data);
	map($data{$_} =~ s/[\s\0x0a\0x0d]+$//, keys %data);
	
	# [̖{ɕt鍷olȂǂpӂ܂B
	($mail_header) = &_OutputHtml_Convert($data{'mail_header'});
	($mail_footer) = &_OutputHtml_Convert($data{'mail_footer'});
	
	#  %work ɐ؂ւ܂B
	%work = %data;
	
	# Mo^܂B
	$send_address = $data{'mail_to'};

	# CC Kvł邩̃`FbNƂ̑ΉłB
	if ($work{'send_back_copy'})
	{
		# ĐƑMقȂꍇɂ̂݁ACc wb_t܂B
		if ($work{'mail_from'} ne $work{'mail_to'})
		{
			$send_address .= " $data{'mail_from'}";
			push @mail_data, "Cc: $data{'mail_from'}";
		}
	}
	
	# . ̃f[^΁AÔ ".." ɕϊ܂B
	map($work{$_} =~ s/^\.$/../, keys %work);
	
	# wb_oOŁAFrom wb_p̕ɉH܂B
	$work{'mail_from'} = &jis_header($work{'name_from'}, 1) . " " . &jis_header("<$work{'mail_from'}>") if ($work{'name_from'});
	
	# Kvȃwb_[o܂B
	map(&_SetHeader($MAIL_HEADERS{$_}, $_), keys %MAIL_HEADERS);
	
	# ŗLwb_o͂܂B
	foreach $header (keys %work)
	{
		if ($header =~ m/^X-/)
		{
			push @mail_data, "$header: " . &jis_header($work{$header});
			delete $work{$header};
		}
	}
	
	# {\ŕsvȗvf폜܂B
	map(delete $work{$_}, @EXCLUDE);
	
	# wb_I
	push @mail_data, '';
	
	# ܂̓[̖{wb_o܂B
	push @mail_data, &jis_body($mail_header);
	
	# ȊȌ͖{Ƃďo܂B
	foreach (keys %work)
	{
		push @mail_data, &jis_body("[*] $_");
		push @mail_data, &jis_body("$work{$_}");
		push @mail_data, '';
	}
	
	# Ė{tb^[o܂B
	push @mail_data, &jis_body($mail_footer);
	
	# Ō "." st܂B
	push @mail_data, ".$MAIL_NEWLINE";	# Ō͂ĉsR[ht
	
	# [̑Ms܂B
	if (open SENDMAIL, "|$data{'sendmail'} $send_address")
	{
		print SENDMAIL join($MAIL_NEWLINE, @mail_data);
		close SENDMAIL;
		
		&OutputHtml("ok", 0, %data);
	}
	else
	{
		&OutputHtml("fail", 0, %data);
	}
}

sub jis_header($$)
{
	my $src = shift;
	my $force = shift;
	
	if ($force || $src =~ m/[^\x20-\x7F]+/)
	{
		$src = '=?ISO-2022-JP?B?' . &base64(&jcode'jis($src)) . '?=';
	}
	
	return $src;
}

sub base64($)
{
    my($buffer) = @_;
    my($result) = '';

    my($i, $j);
    my($org1, $org2, $org3);
    my($part1, $part2, $part3, $part4);
    
    my(@parts);

    # dividing, 1part per 6bit ----

    for ($i = 0; $i < length($buffer); $i += 3)
    {
	$org1 = unpack('C', substr($buffer, $i + 0, 1));
	$org2 = unpack('C', substr($buffer, $i + 1, 1));
	$org3 = unpack('C', substr($buffer, $i + 2, 1));

	$part1 = ($org1 & 0xfc) / 0x04;
	$part2 = ($org1 & 0x03) * 0x10 + (($org2 & 0xf0) / 0x10); 
	$part3 = ($org2 & 0x0f) * 0x04 + (($org3 & 0xc0) / 0x40);
	$part4 = ($org3 & 0x3f);


	push(@parts, $part1);
	push(@parts, $part2);
	push(@parts, $part3) if ($i + 1 < length($buffer));
	push(@parts, $part4) if ($i + 2 < length($buffer));
    }


    # transfer -------

    my($temp);

    for ($i = 0; $i < scalar(@parts); $i += 4)
    {
	for ($j = 0; $j < 4; $j++)
	{
	    if (defined $parts[$i + $j])
	    {
		$temp = $parts[$i + $j];
	    }
	    else
	    {
		$temp = 255;
	    }


	    if ($temp <= 25)
	    {
		$result .= pack('C', unpack('C', 'A') + $temp);
	    }
	    elsif (25 < $temp && $temp <= 51)
	    {
		$result .= pack('C', unpack('C', 'a') + $temp - 26);
	    }
	    elsif (51 < $temp && $temp <= 61)
	    {
		$result .= $temp - 52;
	    }
	    elsif ($temp == 62)
	    {
		$result .= '+';
	    }
	    elsif ($temp == 63)
	    {
		$result .= '/';
	    }
	    else
	    {
		$result .= '=';
	    }
	}
    }

    return $result;
}

sub jis_body($)
{
	return &jcode'jis($_[0]);
}

# ʃy[Wo͂܂B
# $[0]:
#		ok			
#		fail		s
#		not_enough	͍ڕs
#		error		VXeG[
# $[1]: ⏕Berror ɂāA$note ̒lƂĎg܂B
# %[2]: Lf[^
sub OutputHtml($$%)
{
	my $mode = shift;
	my $option = shift;
	local %data = @_;
	
	# jcode 𗘗pۂɂ́Amy ł͂ȂlqB
	$result;
	$note;
	
	my @template;
	my $template_code = $data{'result_template_code'};
	
	my $work;
	
	# ʒm܂B
	if ($mode eq 'ok')
	{
		$result	= $data{'ok_result'};
		$note	= $data{'ok_note'};
	}
	elsif ($mode eq 'fail')
	{
		$result	= $data{'ng_result'};
		$note	= $data{'ng_note'};
	}
	elsif ($mode eq 'not_enough')
	{
		$result = $data{'required_result'};
		$note = "$data{'required_note'}";
	}
	elsif ($mode eq 'error')
	{
		$result = "<font color='red'><b>System Error</b></font>";
		$note = $option;
	}
	else
	{
		$result = "<font color='red'><b>System Error (Program Mistake)</b></font>";
		$note = "unknown mode: $mode: at OutputHtml()";
	}
	
	# ʒm̕R[h𒲐܂B
	&jcode'convert(*result, $template_code);
	&jcode'convert(*note, $template_code);

	# ev[g HTML t@C쐬܂B
	if (open TEMPLATE, $data{'result_template'})
	{
		# Cɓǂݍ݂܂B
		@template = <TEMPLATE>;
		close TEMPLATE;
	}
	else
	{
		# ev[g܂JȂꍇ̉ev[g
		push @template, "<html>\n";
		push @template, "<head>\n";
		push @template, "<title>$IDENTIFIER</title>\n";
		push @template, "</head>\n";
		push @template, "<body>\n";
		push @template, "<h1>/*__RESULT__*/</h1>\n";
		push @template, "<blockquote>\n";
		push @template, "/*__NOTE__*/\n";
		push @template, "</blockquote>\n";
		push @template, "</body>\n";
		push @template, "</html>\n";
	}
	
	# Kvڂuďo͂܂B
	foreach $work (@template)
	{
		## LEVEL 1 ##

		# /*__?????__*/ ̒u
		$work =~ s|/\*__RESULT__\*/|$result|g;
		$work =~ s|/\*__NOTE__\*/|$note|g;

		## LEVEL 2 ##

		# /*__option__*/ ̒u
		$work =~ s|/\*__option__\*/|$option|g;

		#  /**??????**/ ̒u
		($work) = &_OutputHtml_Convert($work);
	}
	
	print "Content-type: text/html\n\n";
	print @template;
}

# ^Ouďo͕𐶐܂B(OutputHtml ̌Ăяopj
# @[r] ϊ̕zŕԂ܂B
# @[1] ϊ镶zŎw肵܂B
# local $data
sub _OutputHtml_Convert(@)
{
	my @result = @_;

	map($_ =~ s|/\*\*([^\s\*]+)\*\*/|$data{$1}|g, @result);
	return @result;
}

# wb_o܂BiSend ̌Ăяopj
# : (local) %work, $CRLF, (param) $_[0] wb_ $_[1] L[
# o: (local) @mail_data ֒ǋL
sub _SetHeader($$)
{
	my ($name, $key) = @_;
	
	push @mail_data, "$name: " . &jis_header($work{$key});
	
	# gL[͏܂B
	delete $work{$key};
}

# $[0] G[bZ[W
sub Error($%)
{
	my $error = shift;
	my %data = @_;
	
	&OutputHtml("error", "CGI Error: EZ-NET Mail Form: $error", %data);
	return 0;
}

# $[0] G[bZ[W
sub ErrorConfig($%)
{
	my $field = shift;
	my %data = @_;
	
	&OutputHtml("not_enough", $field, %data);
	return 0;
}

exit &main();
